<?php

namespace GeorgGriesser\WordPress\Smart_WP\Pages;

class Settings_Page
{

    public function init()
    {
        add_action('admin_menu', array($this, 'add_page'));
    }

    public function add_page()
    {
        $page_hook = add_menu_page('Smart WordPress', 'Smart WordPress', 'manage_options', 'smart-wp', array($this, 'render'), get_smart_wp_plugin_dir_url('img/velocious-logo-yellow.png'));

        add_action('load-' . $page_hook, array($this, 'add_remaining_callbacks'));
    }

    public function add_remaining_callbacks()
    {
        add_action('admin_enqueue_scripts', array($this, 'add_styles'));
        add_action('admin_enqueue_scripts', array($this, 'add_scripts'));
    }

    public function add_styles() {
        wp_enqueue_style('material-icons', 'https://fonts.googleapis.com/icon?family=Material+Icons');
    }


    public function add_scripts()
    {
        $angular_path = get_smart_wp_plugin_dir_url('/angular/backend/dist/');


        $scripts = array(
            'inline.bundle.js',
            'polyfills.bundle.js',
            'styles.bundle.js',
            'vendor.bundle.js',
            'main.bundle.js'
            //'scripts.bundle.js'
        );

        foreach ($scripts as $script) {
            wp_enqueue_script($script, $angular_path . $script, array(), '1.0.5', true);
        }
    }


    public function render()
    {
        printf('<app-root id="smart-wp-container" data-api-url="%1$s" data-plugin-url="%2$s" data-api-nonce="%3$s">Loading...</app-root>',
            str_replace( parse_url( get_rest_url(), PHP_URL_SCHEME ) . ':', '',  get_rest_url() ),
            str_replace( parse_url( get_rest_url(), PHP_URL_SCHEME ) . ':', '',  get_smart_wp_plugin_dir_url() ),
            wp_create_nonce('wp_rest')
        );
    }
}