<?php

namespace GeorgGriesser\WordPress\Smart_WP;

class Api
{

    public static function add_routes()
    {
        Api::add_settings_routes();
    }

    private static function add_route($namespace, $route, $arguments = array(), $override = false)
    {
        register_rest_route(
            $namespace,
            $route,
            $arguments,
            $override
        );
    }

    public static function is_allowed()
    {
        if (self::is_developement_environment()) {
            return true;
        }
        return current_user_can('manage_options');
    }

    private static function is_developement_environment()
    {
        if (defined('VELOCIOUS_DEVELOPMENT')) {
            if (VELOCIOUS_DEVELOPMENT === true) {
                return true;
            }
        }
        return false;
    }

    static function add_settings_routes()
    {
        Api::add_route(
            'smart-wp/v1',
            '/settings',
            array(
                array(
                    'methods' => 'GET',
                    'callback' => array('\GeorgGriesser\WordPress\Smart_WP\Http\Controllers\Setting_Controller', 'get_item'),
                    'permission_callback' => array('\GeorgGriesser\WordPress\Smart_WP\Api', 'is_allowed')
                ),
                array(
                    'methods' => 'POST',
                    'callback' => array('\GeorgGriesser\WordPress\Smart_WP\Http\Controllers\Setting_Controller', 'update_item'),
                    'permission_callback' => array('\GeorgGriesser\WordPress\Smart_WP\Api', 'is_allowed')
                ),
                array(
                    'methods' => 'DELETE',
                    'callback' => array('\GeorgGriesser\WordPress\Smart_WP\Http\Controllers\Setting_Controller', 'delete_item'),
                    'permission_callback' => array('\GeorgGriesser\WordPress\Smart_WP\Api', 'is_allowed')
                )
            )
        );
    }
}