<?php

namespace GeorgGriesser\WordPress\Smart_WP;

use GeorgGriesser\WordPress\Smart_WP\Header_Manager\Archive_Header_Manager;
use GeorgGriesser\WordPress\Smart_WP\Header_Manager\Object_Header_Manager;

class Plugin
{
    function add_headers()
    {

        if (defined('DOING_AJAX') && DOING_AJAX) {

            return;
        } elseif (defined('XMLRPC_REQUEST') && XMLRPC_REQUEST) {

            return;
        } elseif (defined('REST_REQUEST') && REST_REQUEST) {

            return;
        } elseif (is_admin()) {

            return;
        }


        $options = Setting::get();

        $archive_header_manager = new Archive_Header_Manager($options);
        $object_header_manager = new Object_Header_Manager($options);

        if (is_feed()) {
            $post = $this->get_post_archive();

            if (false === $post) {
                return;
            }

            $archive_header_manager->set_headers($post);
            $archive_header_manager->send_headers();

        } elseif (is_singular()) {
            $object_header_manager->set_headers($this->get_post_object());
            $object_header_manager->send_headers();

        } elseif (is_archive() || is_search() || is_home()) {
            $post = $this->get_post_archive();

            if (false === $post) {
                return;
            }

            $archive_header_manager->set_headers($post);
            $object_header_manager->send_headers();
        }
    }

    private function get_post_archive() {
        global $posts;
        if (empty($posts)) {
            return false;
        }
        return $posts[0];
    }

    private function get_post_object() {
        return get_queried_object();
    }
}